#ifndef __DATAINPUTWINDOW_HPP
#define __DATAINPUTWINDOW_HPP

#include <SophiaFramework.hpp>

// EBhE\ɂ́ASFRTitleWindow pNX쐬
SFMTYPEDEFCLASS(DataInputWindow)
class DataInputWindow : public SFRPlainWindow {
    SFMSEALCOPY(DataInputWindow)
protected:
    SFREditboxControlPtr _textHour;             // ԓ̓eLXgRg[
    SFREditboxControlPtr _textMinute;           // ̓eLXgRg[
    SFREditboxControlPtr _textContent;          // e̓eLXgRg[t
    SFRButtonControlPtr _buttonOk;              // OK {^
    SFRButtonControlPtr _buttonCancel;          // LZ{^
    SFRLabelControlPtr _labelDate;              // x
    SFRLabelControlPtr _labelHour;              // ԃx
    SFRLabelControlPtr _labelMinute;            // x
    SInt16 _fontHeight;                         // tHg̍
    SFXDateConst _date;                         // ̓t
public:
    DataInputWindow(SFXDateConstRef date) static_throws;
    virtual ~DataInputWindow(Void);
    virtual Void MakeData(SFXDateConstRef start, SFXAnsiStringConstRef summary) = 0;

    HANDLER_DECLARE_VOIDRENDER(OnRenderContent)         // `nh
    HANDLER_DECLARE_BOOLEVENT(OnKey)                    // L[nh
    HANDLER_DECLARE_VOIDCONTROL(OnOkButtonControl)      // {^nh
    HANDLER_DECLARE_VOIDCONTROL(OnCancelButtonControl)  // {^nh
    private:
    SFRResponderPtr next;
    HANDLER_DECLARE_VOIDCONTROL(OnEditboxHandler)       // eLXg̓nh
};

SFMTYPEDEFCLASS(CreateWindow)
class CreateWindow : public DataInputWindow {
    SFMSEALCOPY(CreateWindow)
public:
    CreateWindow(SFXDateConstRef date);
    virtual Void MakeData(SFXDateConstRef start, SFXAnsiStringConstRef summary);
};

SFMTYPEDEFCLASS(ModifyWindow)
class ModifyWindow : public DataInputWindow {
    SFMSEALCOPY(ModifyWindow)
private:
    VCalendarFilePtr _vcal;                 // Cf[^ێ
public:
    ModifyWindow(SFXDateConstRef date, VCalendarFilePtr vcal);
    virtual Void MakeData(SFXDateConstRef start, SFXAnsiStringConstRef summary);
};

#endif //__DATAINPUTWINDOW_HPP
